"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Literal
from datetime import datetime

from pydantic import Field

from githubkit.utils import UNSET
from githubkit.typing import Missing
from githubkit.compat import GitHubModel, model_rebuild


class RuleSuitesItems(GitHubModel):
    """RuleSuitesItems"""

    id: Missing[int] = Field(
        default=UNSET, description="The unique identifier of the rule insight."
    )
    actor_id: Missing[int] = Field(
        default=UNSET, description="The number that identifies the user."
    )
    actor_name: Missing[str] = Field(
        default=UNSET, description="The handle for the GitHub user account."
    )
    before_sha: Missing[str] = Field(
        default=UNSET, description="The first commit sha before the push evaluation."
    )
    after_sha: Missing[str] = Field(
        default=UNSET, description="The last commit sha in the push evaluation."
    )
    ref: Missing[str] = Field(
        default=UNSET, description="The ref name that the evaluation ran on."
    )
    repository_id: Missing[int] = Field(
        default=UNSET,
        description="The ID of the repository associated with the rule evaluation.",
    )
    repository_name: Missing[str] = Field(
        default=UNSET,
        description="The name of the repository without the `.git` extension.",
    )
    pushed_at: Missing[datetime] = Field(default=UNSET)
    result: Missing[Literal["pass", "fail", "bypass"]] = Field(
        default=UNSET,
        description="The result of the rule evaluations for rules with the `active` enforcement status.",
    )
    evaluation_result: Missing[Literal["pass", "fail"]] = Field(
        default=UNSET,
        description="The result of the rule evaluations for rules with the `active` and `evaluate` enforcement statuses, demonstrating whether rules would pass or fail if all rules in the rule suite were `active`.",
    )


model_rebuild(RuleSuitesItems)

__all__ = ("RuleSuitesItems",)
