"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import List, Union

from pydantic import Field

from githubkit.utils import UNSET
from githubkit.typing import Missing
from githubkit.compat import GitHubModel, model_rebuild


class CodeownersErrors(GitHubModel):
    """CODEOWNERS errors

    A list of errors found in a repo's CODEOWNERS file
    """

    errors: List[CodeownersErrorsPropErrorsItems] = Field()


class CodeownersErrorsPropErrorsItems(GitHubModel):
    """CodeownersErrorsPropErrorsItems"""

    line: int = Field(description="The line number where this errors occurs.")
    column: int = Field(description="The column number where this errors occurs.")
    source: Missing[str] = Field(
        default=UNSET, description="The contents of the line where the error occurs."
    )
    kind: str = Field(description="The type of error.")
    suggestion: Missing[Union[str, None]] = Field(
        default=UNSET,
        description="Suggested action to fix the error. This will usually be `null`, but is provided for some common errors.",
    )
    message: str = Field(
        description="A human-readable description of the error, combining information from multiple fields, laid out for display in a monospaced typeface (for example, a command-line setting)."
    )
    path: str = Field(description="The path of the file where the error occured.")


model_rebuild(CodeownersErrors)
model_rebuild(CodeownersErrorsPropErrorsItems)

__all__ = (
    "CodeownersErrors",
    "CodeownersErrorsPropErrorsItems",
)
