"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import List, Union, Literal

from pydantic import Field

from githubkit.utils import UNSET
from githubkit.typing import Missing
from githubkit.compat import GitHubModel, model_rebuild

from .group_0378 import Meta


class ScimEnterpriseGroupResponse(GitHubModel):
    """ScimEnterpriseGroupResponse"""

    schemas: List[
        Literal[
            "urn:ietf:params:scim:schemas:core:2.0:Group",
            "urn:ietf:params:scim:api:messages:2.0:ListResponse",
        ]
    ] = Field(
        description="The URIs that are used to indicate the namespaces of the SCIM schemas."
    )
    external_id: Missing[Union[str, None]] = Field(
        default=UNSET,
        alias="externalId",
        description="A unique identifier for the resource as defined by the provisioning client.",
    )
    display_name: Missing[Union[str, None]] = Field(
        default=UNSET,
        alias="displayName",
        description="A human-readable name for a security group.",
    )
    members: Missing[List[ScimEnterpriseGroupResponseMergedMembers]] = Field(
        default=UNSET, description="The group members."
    )
    id: Missing[str] = Field(
        default=UNSET, description="The internally generated id for the group object."
    )
    meta: Missing[Meta] = Field(
        default=UNSET,
        description="The metadata associated with the creation/updates to the user.",
    )


class ScimEnterpriseGroupResponseMergedMembers(GitHubModel):
    """ScimEnterpriseGroupResponseMergedMembers"""

    value: str = Field(description="The local unique identifier for the member")
    ref: str = Field(alias="$ref")
    display: Missing[str] = Field(
        default=UNSET, description="The display name associated with the member"
    )


class ScimEnterpriseGroupList(GitHubModel):
    """ScimEnterpriseGroupList"""

    schemas: List[Literal["urn:ietf:params:scim:api:messages:2.0:ListResponse"]] = (
        Field(
            description="The URIs that are used to indicate the namespaces of the list SCIM schemas."
        )
    )
    total_results: int = Field(
        alias="totalResults", description="Number of results found"
    )
    resources: List[ScimEnterpriseGroupResponse] = Field(
        alias="Resources", description="Information about each provisioned group."
    )
    start_index: int = Field(
        alias="startIndex", description="A starting index for the returned page"
    )
    items_per_page: int = Field(
        alias="itemsPerPage", description="Number of objects per page"
    )


model_rebuild(ScimEnterpriseGroupResponse)
model_rebuild(ScimEnterpriseGroupResponseMergedMembers)
model_rebuild(ScimEnterpriseGroupList)

__all__ = (
    "ScimEnterpriseGroupResponse",
    "ScimEnterpriseGroupResponseMergedMembers",
    "ScimEnterpriseGroupList",
)
