"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Union
from datetime import datetime

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild


class SimpleCommit(GitHubModel):
    """Simple Commit

    A commit.
    """

    id: str = Field(description="SHA for the commit")
    tree_id: str = Field(description="SHA for the commit's tree")
    message: str = Field(description="Message describing the purpose of the commit")
    timestamp: datetime = Field(description="Timestamp of the commit")
    author: Union[SimpleCommitPropAuthor, None] = Field(
        description="Information about the Git author"
    )
    committer: Union[SimpleCommitPropCommitter, None] = Field(
        description="Information about the Git committer"
    )


class SimpleCommitPropAuthor(GitHubModel):
    """SimpleCommitPropAuthor

    Information about the Git author
    """

    name: str = Field(description="Name of the commit's author")
    email: str = Field(description="Git email address of the commit's author")


class SimpleCommitPropCommitter(GitHubModel):
    """SimpleCommitPropCommitter

    Information about the Git committer
    """

    name: str = Field(description="Name of the commit's committer")
    email: str = Field(description="Git email address of the commit's committer")


model_rebuild(SimpleCommit)
model_rebuild(SimpleCommitPropAuthor)
model_rebuild(SimpleCommitPropCommitter)

__all__ = (
    "SimpleCommit",
    "SimpleCommitPropAuthor",
    "SimpleCommitPropCommitter",
)
